#!/usr/bin/perl

use IO::Socket;
use MIME::Base64;

# usage:
# insert_blob.pl <INSERT arguments> <blob filename>\n";

####################
### PROGRAM BODY ###
####################


$KLUDGE_host = "localhost";
$KLUDGE_port = "11111";

$socket = IO::Socket::INET->new(PeerAddr => $KLUDGE_host,
                                PeerPort => $KLUDGE_port,
                                Proto    => "tcp",
                                Type     => SOCK_STREAM)
    or die "Couldn't connect to $KLUDGE_host:$KLUDGE_port : $@\n";

my $raw;
my $USAGE = "Usage:\ninsert_blob.pl <INSERT arguments> <blob filename>";

my $params = shift or die "\"INSERT\" arguments are missing.\n $USAGE\n";
my $filename = shift or die "Filename missing.\n $USAGE\n";

open(INPUT_FILE, "<$filename");
while (<INPUT_FILE>)
{
   $raw .= $_;
}
close(INPUT_FILE);

my $encoded = encode_base64($raw);

Wait_For_Kludge_Prompt(SOCKET => $socket);

print $socket "INSERT $params {\n"; 

print $socket $encoded;

print $socket "\n";
print $socket "\n";
Wait_For_Kludge_Prompt(SOCKET => $socket);

print $socket "};\n";

# close the KLUDGE connection in a polite way.
print $socket "QUIT;","\n";

while (<$socket>)
{
   if (/Bye/)
   {
      close($socket);
      exit(0);
   }
}



###################
### SUBROUTINES ###
###################

sub Wait_For_Kludge_Prompt
{
   my %args = 
   (
      SOCKET => \*STDOUT,
      @_
   );
   local $qry_sock = $args{SOCKET};
   
   local $prompt_encountered = 0;
   while (! $prompt_encountered)
   {
      $first_char = getc($qry_sock);
      print $first_char;
      if ($first_char =~ />/)
      {
         getc($qry_sock);              # eats the space following the prompt
         $prompt_encountered = 1;
      }
   }
   print "\n";
}
