#include <unistd.h>    //provides close()
#include "kludge_engine.h"
#include "kludge_threads.h"

// from kludge_threads.cc
extern int fatal_error;

int main(int argc, char *argv[], char *env[])
{
 int master_socket;
 string listen_address = "localhost";
 unsigned short int listen_port = 11111;
 
   fatal_error = 0;

   // if one of the options is "--help", the following function will exit().
   Get_Options(argc, argv, listen_address, listen_port); // input, input, output, output
   
   Kludge_pl_init(); // perl init

   // FD 1 = std.out; We also need to know the default Perl thread.
   Pseudo_Master_Thread = new Kludge_Thread(1,Kludge_pl_get_deflt_thread());
   Kludge_Root = new Kludge_Root_Object;

   //Kludge_Root->Classes->Load_Children(my_connection, /*recursive?*/true);

   // sockets stuff
   master_socket = tcp_listen_at(listen_address.c_str(), listen_port, 5);
   if (master_socket == -1)
   {
      process_error();
   }
   else
   {
      accept_clients(master_socket);

      if (close(master_socket) != 0)
      {
         process_error();
      }
      else cout << "Master socket closed.\n";
   }
   // done with the sockets

   delete Kludge_Root;
   delete Pseudo_Master_Thread; // This should better not close stdout (FD 1)...

   Kludge_pl_shutdown();
   Clean_Up_Global_Indexes();

   exit(fatal_error);
}
