/*
This is          kludge_mysql.h

-- Defines some connection parameter macros and declares a few mysql-related
-- functions to be used by the rest of Kludge (mainly by kludge_engine.cc).
*/


#include <mysql.h>
#include <string>


#ifndef _KLUDGE_MYSQL_H
#define _KLUDGE_MYSQL_H

// mysql connection parameters - declared in kludge_mysql.cc
extern string mysql_hostname;
extern string mysql_username;
extern string mysql_password;
extern string mysql_db_name;
extern unsigned int mysql_remoteport;


class Kludge_MYSQL_RES
{
public:
   MYSQL_ROW Row;
   MYSQL_RES* Result;
   Kludge_MYSQL_RES(MYSQL_ROW row, MYSQL_RES* result) : Row(row), Result(result) {}
   ~Kludge_MYSQL_RES() { mysql_free_result(Result); }
};

MYSQL *kludge_mysql_init();

MYSQL_RES *kludge_mysql_query(const char *qry_string, MYSQL *conn); // returns table entries
int kludge_mysql_cmd(const char *qry_string, MYSQL *conn); // returns success/failure


#endif // _KLUDGE_MYSQL_H
